/*
 * Mirai. Copyright (C) 2024 Vyn
 * This file is licensed under version 3 of the GNU General Public License (GPL-3.0-only)
 * The license can be found in the LICENSE file or at https://www.gnu.org/licenses/gpl-3.0.txt
 */

#include "utils.h"
#include <cctype>
#include <functional>
#include <optional>

namespace mirai
{

bool isDate(const std::string &dateStr)
{
	// std regex are really slow
	/*std::regex regex("[0-9]{4}-[0-9]{2}-[0-9]{2}");*/
	/*return std::regex_match(dateStr, regex);*/

	// Quick hand made check instead of regex until I rework date to use timestamp or std::chrono
	if (dateStr.length() != 10) {
		return false;
	}

	if (dateStr[4] != '-' || dateStr[7] != '-') {
		return false;
	}

	for (int i = 0; i < dateStr.length(); ++i) {
		if (i == 4 || i == 7) {
			// These are the '-' characters
			continue;
		}
		if (!isdigit(dateStr[i])) {
			return false;
		}
	}
	return true;
}

int generateUniqueId()
{
	static int nextId = 0;
	return nextId++;
}
} // namespace mirai
